

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>network_extensions.igraphx.graph_plotly &mdash; NetExt1 1 documentation</title>
  

  
  
  
  

  
  <script type="text/javascript" src="../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script src="../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> NetExt1
          

          
          </a>

          
            
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../igraphx.html">Network network_extensions.igraphx</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../multilayer.html">Network network_extensions.multilayer</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../simulations.html">Network igraphx_simulations.simulations</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../semantic.html">Network network_extensions.semantic</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../structure_simulations.html">Result structure of a simulation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../graph_plotly.html">Helpers for plotly</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">NetExt1</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../index.html">Module code</a> &raquo;</li>
        
          <li><a href="../igraphx.html">network_extensions.igraphx</a> &raquo;</li>
        
      <li>network_extensions.igraphx.graph_plotly</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for network_extensions.igraphx.graph_plotly</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">Some helpers to plot the networks with plotly (https://plot.ly)</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">import</span> <span class="nn">plotly.graph_objs</span> <span class="k">as</span> <span class="nn">go</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">igraph</span>
<span class="kn">import</span> <span class="nn">logging</span>
<span class="n">logger</span> <span class="o">=</span> <span class="n">logging</span><span class="o">.</span><span class="n">getLogger</span><span class="p">(</span><span class="vm">__name__</span><span class="p">)</span>
<span class="k">def</span> \
<div class="viewcode-block" id="createSizeFromFunc"><a class="viewcode-back" href="../../../graph_plotly.html#network_extensions.igraphx.graph_plotly.createSizeFromFunc">[docs]</a>        <span class="nf">createSizeFromFunc</span><span class="p">(</span><span class="n">gr</span><span class="p">:</span> <span class="n">igraph</span><span class="o">.</span><span class="n">Graph</span><span class="p">,</span> <span class="n">func</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s2">&quot;betweenness&quot;</span><span class="p">,</span> <span class="n">min_size</span><span class="p">:</span> <span class="nb">float</span> <span class="o">=</span> <span class="mi">2</span><span class="p">,</span> <span class="n">scale_size</span><span class="p">:</span> <span class="nb">float</span> <span class="o">=</span> <span class="mi">10</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Creates an numpy array with sizes for each vertex in the graph.</span>

<span class="sd">    :param gr: igraph.Graph object</span>
<span class="sd">    :param func: (optional) the name of a method of gr which calculates a numerical value for each vertex. Defaults to &quot;betweenness&quot;.</span>
<span class="sd">    :param min_size: the minimal size of each vertex</span>
<span class="sd">    :param scale_size: maximal size of each vertex</span>
<span class="sd">    :return: np.array</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">betw</span> <span class="o">=</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">gr</span><span class="p">,</span><span class="n">func</span><span class="p">)()</span>

    <span class="k">if</span> <span class="nb">max</span><span class="p">(</span><span class="n">betw</span><span class="p">)</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">:</span>
        <span class="n">sizes</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">betw</span><span class="p">)</span> <span class="o">/</span> <span class="nb">max</span><span class="p">(</span><span class="n">betw</span><span class="p">)</span> <span class="o">*</span> <span class="n">scale_size</span> <span class="o">+</span> <span class="n">min_size</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">sizes</span> <span class="o">=</span> <span class="n">min_size</span>
    <span class="k">return</span> <span class="n">sizes</span></div>


<div class="viewcode-block" id="createFigGraph"><a class="viewcode-back" href="../../../graph_plotly.html#network_extensions.igraphx.graph_plotly.createFigGraph">[docs]</a><span class="k">def</span> <span class="nf">createFigGraph</span><span class="p">(</span><span class="n">gr</span><span class="p">:</span> <span class="n">igraph</span><span class="o">.</span><span class="n">Graph</span><span class="p">,</span> <span class="n">title</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">hover_field</span><span class="p">:</span><span class="nb">str</span> <span class="o">=</span> <span class="s2">&quot;label&quot;</span><span class="p">,</span> <span class="n">sizes</span><span class="p">:</span> <span class="nb">object</span> <span class="o">=</span> <span class="mi">2</span><span class="p">,</span> <span class="n">typ_field</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">pos</span><span class="p">:</span> <span class="nb">list</span> <span class="o">=</span> <span class="kc">None</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">go</span><span class="o">.</span><span class="n">Figure</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    create figure for plotly</span>

<span class="sd">    :param gr: graph to be plotted</span>
<span class="sd">    :param title: title of the plot</span>
<span class="sd">    :param sizes: can be an float or an array, defines size for each vertex</span>
<span class="sd">    :param hover_field: property of the node to be displayed (defaults to label)</span>
<span class="sd">    :param typ_field: if set the generate 3d perspective</span>
<span class="sd">    :param pos: array with x,y coodinates for each vertex. If none layout_fruchterman_reingold() is called.</span>
<span class="sd">    :return: figure which than can be used by plotly</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">if</span> <span class="n">typ_field</span><span class="p">:</span>
        <span class="n">typs</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">gr</span><span class="o">.</span><span class="n">vs</span><span class="p">[</span><span class="n">typ_field</span><span class="p">])</span>
        <span class="n">Zn</span> <span class="o">=</span><span class="n">gr</span><span class="o">.</span><span class="n">vs</span><span class="p">[</span><span class="n">typ_field</span><span class="p">]</span>


    <span class="k">if</span> <span class="ow">not</span> <span class="n">pos</span><span class="p">:</span>
        <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;create positions&quot;</span><span class="p">)</span>
        <span class="n">pos</span> <span class="o">=</span> <span class="n">gr</span><span class="o">.</span><span class="n">layout_fruchterman_reingold</span><span class="p">()</span>
    <span class="n">Xn</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">pos</span><span class="o">.</span><span class="n">coords</span><span class="p">]</span>  <span class="c1"># x-coordinates of nodes</span>
    <span class="n">Yn</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">pos</span><span class="o">.</span><span class="n">coords</span><span class="p">]</span>  <span class="c1"># x-coordinates of nodes</span>



    <span class="n">Xe</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">Ye</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">Ze</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;create edges&quot;</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">e</span> <span class="ow">in</span> <span class="n">gr</span><span class="o">.</span><span class="n">es</span><span class="p">:</span>
        <span class="n">Xe</span> <span class="o">+=</span> <span class="p">[</span><span class="n">pos</span><span class="o">.</span><span class="n">coords</span><span class="p">[</span><span class="n">e</span><span class="o">.</span><span class="n">source</span><span class="p">][</span><span class="mi">0</span><span class="p">],</span> <span class="n">pos</span><span class="o">.</span><span class="n">coords</span><span class="p">[</span><span class="n">e</span><span class="o">.</span><span class="n">target</span><span class="p">][</span><span class="mi">0</span><span class="p">],</span> <span class="kc">None</span><span class="p">]</span>  <span class="c1"># x-coordinates of edge ends</span>
        <span class="n">Ye</span> <span class="o">+=</span> <span class="p">[</span><span class="n">pos</span><span class="o">.</span><span class="n">coords</span><span class="p">[</span><span class="n">e</span><span class="o">.</span><span class="n">source</span><span class="p">][</span><span class="mi">1</span><span class="p">],</span> <span class="n">pos</span><span class="o">.</span><span class="n">coords</span><span class="p">[</span><span class="n">e</span><span class="o">.</span><span class="n">target</span><span class="p">][</span><span class="mi">1</span><span class="p">],</span> <span class="kc">None</span><span class="p">]</span>

        <span class="k">if</span> <span class="n">typ_field</span><span class="p">:</span>
            <span class="n">Ze</span> <span class="o">+=</span> <span class="p">[</span><span class="n">Zn</span><span class="p">[</span><span class="n">e</span><span class="o">.</span><span class="n">source</span><span class="p">],</span><span class="n">Zn</span><span class="p">[</span><span class="n">e</span><span class="o">.</span><span class="n">target</span><span class="p">],</span> <span class="kc">None</span><span class="p">]</span>

    <span class="c1">#texts = [&quot;%s-%s&quot; % (e[&quot;year_s&quot;], e[&quot;year_e&quot;]) for e in gr.es]</span>

    <span class="n">tr1_params</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span><span class="n">x</span><span class="o">=</span><span class="n">Xe</span><span class="p">,</span>
                        <span class="n">y</span><span class="o">=</span><span class="n">Ye</span><span class="p">,</span>
                        <span class="n">mode</span><span class="o">=</span><span class="s1">&#39;lines&#39;</span><span class="p">,</span>
                        <span class="n">line</span><span class="o">=</span><span class="nb">dict</span><span class="p">(</span><span class="n">color</span><span class="o">=</span><span class="s1">&#39;rgb(10,20,20)&#39;</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mf">0.1</span><span class="p">),</span>
                        <span class="c1">#text=texts,</span>
                        <span class="n">hoverinfo</span><span class="o">=</span><span class="s1">&#39;text&#39;</span>
                        <span class="p">)</span>




    <span class="k">if</span> <span class="n">typ_field</span><span class="p">:</span>
        <span class="n">scatter</span> <span class="o">=</span> <span class="n">go</span><span class="o">.</span><span class="n">Scatter3d</span>
        <span class="n">tr1_params</span><span class="p">[</span><span class="s2">&quot;z&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">Ze</span>

    <span class="k">else</span><span class="p">:</span>
        <span class="n">scatter</span> <span class="o">=</span> <span class="n">go</span><span class="o">.</span><span class="n">Scatter</span>

    <span class="n">trace1</span> <span class="o">=</span> <span class="n">scatter</span><span class="p">(</span><span class="o">**</span><span class="n">tr1_params</span><span class="p">)</span>


    <span class="n">tr2_params</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span><span class="n">x</span><span class="o">=</span><span class="n">Xn</span><span class="p">,</span>
                        <span class="n">y</span><span class="o">=</span><span class="n">Yn</span><span class="p">,</span>
                        <span class="n">mode</span><span class="o">=</span><span class="s1">&#39;markers&#39;</span><span class="p">,</span>
                        <span class="n">name</span><span class="o">=</span><span class="s1">&#39;actors&#39;</span><span class="p">,</span>
                        <span class="n">marker</span><span class="o">=</span><span class="nb">dict</span><span class="p">(</span><span class="n">symbol</span><span class="o">=</span><span class="s1">&#39;circle&#39;</span><span class="p">,</span>
                                    <span class="n">size</span><span class="o">=</span><span class="n">sizes</span><span class="p">,</span>
                                    <span class="c1"># color=group,</span>
                                    <span class="n">colorscale</span><span class="o">=</span><span class="s1">&#39;Viridis&#39;</span><span class="p">,</span>
                                    <span class="n">line</span><span class="o">=</span><span class="nb">dict</span><span class="p">(</span><span class="n">color</span><span class="o">=</span><span class="s1">&#39;rgb(240,240,240)&#39;</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mf">0.5</span><span class="p">)</span>
                                    <span class="p">),</span>
                        <span class="n">text</span><span class="o">=</span><span class="n">gr</span><span class="o">.</span><span class="n">vs</span><span class="p">[</span><span class="n">hover_field</span><span class="p">],</span>
                        <span class="n">hoverinfo</span><span class="o">=</span><span class="s1">&#39;text&#39;</span>
                        <span class="p">)</span>

    <span class="k">if</span> <span class="n">typ_field</span><span class="p">:</span>
        <span class="n">tr2_params</span><span class="p">[</span><span class="s2">&quot;z&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">Zn</span>



    <span class="n">trace2</span> <span class="o">=</span> <span class="n">scatter</span><span class="p">(</span><span class="o">**</span><span class="n">tr2_params</span><span class="p">)</span>

    <span class="n">axis</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span><span class="n">showbackground</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                <span class="n">showline</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                <span class="n">zeroline</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                <span class="n">showgrid</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                <span class="n">showticklabels</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                <span class="n">title</span><span class="o">=</span><span class="s1">&#39;&#39;</span>
                <span class="p">)</span>

    <span class="n">layout</span> <span class="o">=</span> <span class="n">go</span><span class="o">.</span><span class="n">Layout</span><span class="p">(</span>
        <span class="n">title</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">width</span><span class="o">=</span><span class="mi">1000</span><span class="p">,</span>
        <span class="n">height</span><span class="o">=</span><span class="mi">1000</span><span class="p">,</span>
        <span class="n">showlegend</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
        <span class="n">scene</span><span class="o">=</span><span class="nb">dict</span><span class="p">(</span>
            <span class="n">xaxis</span><span class="o">=</span><span class="nb">dict</span><span class="p">(</span><span class="n">axis</span><span class="p">),</span>
            <span class="n">yaxis</span><span class="o">=</span><span class="nb">dict</span><span class="p">(</span><span class="n">axis</span><span class="p">),</span>
            <span class="n">zaxis</span><span class="o">=</span><span class="nb">dict</span><span class="p">(</span><span class="n">axis</span><span class="p">),</span>
        <span class="p">),</span>
        <span class="n">margin</span><span class="o">=</span><span class="nb">dict</span><span class="p">(</span>
            <span class="n">t</span><span class="o">=</span><span class="mi">100</span>
        <span class="p">),</span>
        <span class="n">hovermode</span><span class="o">=</span><span class="s1">&#39;closest&#39;</span><span class="p">,</span>
        <span class="n">annotations</span><span class="o">=</span><span class="p">[</span>
            <span class="nb">dict</span><span class="p">(</span>
                <span class="n">showarrow</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                <span class="n">text</span><span class="o">=</span><span class="n">title</span><span class="p">,</span>
                <span class="n">xref</span><span class="o">=</span><span class="s1">&#39;paper&#39;</span><span class="p">,</span>
                <span class="n">yref</span><span class="o">=</span><span class="s1">&#39;paper&#39;</span><span class="p">,</span>
                <span class="n">x</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span>
                <span class="n">y</span><span class="o">=</span><span class="mf">0.1</span><span class="p">,</span>
                <span class="n">xanchor</span><span class="o">=</span><span class="s1">&#39;left&#39;</span><span class="p">,</span>
                <span class="n">yanchor</span><span class="o">=</span><span class="s1">&#39;bottom&#39;</span><span class="p">,</span>
                <span class="n">font</span><span class="o">=</span><span class="nb">dict</span><span class="p">(</span>
                    <span class="n">size</span><span class="o">=</span><span class="mi">14</span>
                <span class="p">)</span>
            <span class="p">)</span>
        <span class="p">],</span> <span class="p">)</span>

    <span class="n">data</span> <span class="o">=</span> <span class="p">[</span><span class="n">trace1</span><span class="p">,</span> <span class="n">trace2</span><span class="p">]</span>
    <span class="c1"># data=[trace2]</span>
    <span class="n">fig</span> <span class="o">=</span> <span class="n">go</span><span class="o">.</span><span class="n">Figure</span><span class="p">(</span><span class="n">data</span><span class="o">=</span><span class="n">data</span><span class="p">,</span> <span class="n">layout</span><span class="o">=</span><span class="n">layout</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">fig</span></div>



</pre></div>

           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, Dirk Wintergrün

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>